//
//
//                                                           %__________%
//                                                          %/ . .  .   \%
//           Van Gogh 2D-Display Library                     |  . .  o. |
//                                                           |. _  .   .|
//        Microsoft Windows 95/98/NT Version                 | / \   .  |
//                                                           |_|_|_._._.|
//                                                           |.-.-.-.-..|
//                                                          %\__________/%
//                                                           %          %
//
//  Copyright (c) 1994-1999 by Dan Higdon, Tim Little, and Chuck Walbourn
//
//
//
// This file and all associated files are subject to the terms of the
// GNU Lesser General Public License version 2 as published by the
// Free Software Foundation (http://www.gnu.org).   They remain the
// property of the authors: Dan Higdon, Tim Little, and Chuck Walbourn.
// See LICENSE.TXT in the distribution for a copy of this license.
//
// THE AUTHORS MAKE NO WARRANTIES, EXPRESS OR IMPLIED, AS TO THE CORRECTNESS
// OF THIS CODE OR ANY DERIVATIVE WORKS WHICH INCORPORATE IT.  THE AUTHORS
// PROVIDE THE CODE ON AN "AS-IS" BASIS AND EXPLICITLY DISCLAIMS ANY
// LIABILITY, INCLUDING CONSEQUENTIAL AND INCIDENTAL DAMAGES FOR ERRORS,
// OMISSIONS, AND OTHER PROBLEMS IN THE CODE.
//
//
//
//                        http://www.mythos-engine.org/
//
//
//
// Created by Dan Higdon & Chuck Walbourn
//
// dialog.h
//
// PalTool dialog classes.
//
//

//
//
//                                Classes
//
//

//
// Properties Dialog 
//

//
// CPropertiesDlgA
//
class CPropertiesDlgA : public CPropertyPage
{
        DECLARE_DYNCREATE(CPropertiesDlgA)

// Construction
public:
        CPropertiesDlgA();
        ~CPropertiesDlgA();

// Dialog Data
        //{{AFX_DATA(CPropertiesDlgA)
        enum { IDD = IDD_PROPA };
        CString m_name;
        BOOL    m_8bit;
        BOOL    m_15bit;
        BOOL    m_16bit;
        BOOL    m_24bit;
        long    m_midpoint;
        long    m_slevels;
        //}}AFX_DATA


// Overrides
        // ClassWizard generate virtual function overrides
        //{{AFX_VIRTUAL(CPropertiesDlgA)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        // Generated message map functions
        //{{AFX_MSG(CPropertiesDlgA)
                // NOTE: the ClassWizard will add member functions here
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()

};


//
// CPropertiesDlgB
//
class CPropertiesDlgB : public CPropertyPage
{
        DECLARE_DYNCREATE(CPropertiesDlgB)

// Construction
public:
        CPropertiesDlgB();
        ~CPropertiesDlgB();

// Dialog Data
        //{{AFX_DATA(CPropertiesDlgB)
        enum { IDD = IDD_PROPB };
                // NOTE - ClassWizard will add data members here.
                //    DO NOT EDIT what you see in these blocks of generated code !
        //}}AFX_DATA


// Overrides
        // ClassWizard generate virtual function overrides
        //{{AFX_VIRTUAL(CPropertiesDlgB)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        // Generated message map functions
        //{{AFX_MSG(CPropertiesDlgB)
                // NOTE: the ClassWizard will add member functions here
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()

};


//
// CPropertiesDlgC
//
class CPropertiesDlgC : public CPropertyPage
{
        DECLARE_DYNCREATE(CPropertiesDlgC)

// Construction
public:
        CPropertiesDlgC();
        ~CPropertiesDlgC();

// Dialog Data
        //{{AFX_DATA(CPropertiesDlgC)
        enum { IDD = IDD_PROPC };
        CString m_auth;
        CString m_copy;
        CString m_desc;
        //}}AFX_DATA


// Overrides
        // ClassWizard generate virtual function overrides
        //{{AFX_VIRTUAL(CPropertiesDlgC)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        // Generated message map functions
        //{{AFX_MSG(CPropertiesDlgC)
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()

};



//
// Palette Dialog 
//

//
// CPaletteDlg
//
class CPaletteDlg : public CDialog
{
// Construction
public:
        CPaletteDlg(dword i=0, VngoPal *p=0, CWnd* pParent = NULL);   // standard constructor

    dword           index;
    VngoColor24bit  pal[VNGO_PAL_SIZE];

// Dialog Data
        //{{AFX_DATA(CPaletteDlg)
        enum { IDD = IDD_PALETTE };
        CScrollBar      m_bluescroll;
        CScrollBar      m_greenscroll;
        CScrollBar      m_redscroll;
        CComboBox       m_indlist;
        BYTE    m_red;
        BYTE    m_green;
        BYTE    m_blue;
        //}}AFX_DATA

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CPaletteDlg)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:

        // Generated message map functions
        //{{AFX_MSG(CPaletteDlg)
        afx_msg void OnColor();
        afx_msg void OnIndexSelectChange();
        afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};



//
// Progress Dialog 
//

//
// CProgressDlg dialog
//
class CProgressDlg : public CDialog
{
// Construction
public:
        CProgressDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CProgressDlg)
        enum { IDD = IDD_PROGRESS };
        CProgressCtrl   m_pbar;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CProgressDlg)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:

        // Generated message map functions
        //{{AFX_MSG(CProgressDlg)
                // NOTE: the ClassWizard will add member functions here
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

// eof - dialog.h 
